varying vec2 ouv;
varying vec4 opos_w;
varying float vfogf;
uniform vec4 fog_colour;//+30
uniform vec4 surface_ambient_colour;//+32
uniform vec4 surface_diffuse_colour;//+33
uniform vec4 light_diffuse_colour;//+39
uniform vec4 light_pos;//+43
uniform vec4 camera_pos;//+76
uniform float time;//+86
uniform sampler2D diffuseMap;//0
uniform int layer;//2
uniform float speed;//0.1
void main()
{
vec3 camdir=normalize(opos_w.xyz-camera_pos.xyz);
vec3 camlight =normalize(light_pos.xyz-camera_pos.xyz);
float cdcl=max(dot(camdir,camlight),0);
float hzinf=cdcl*pow(length(camdir.xz),10);
vec4 color=mix(surface_ambient_colour,surface_diffuse_colour,hzinf);
float suncolor=pow(cdcl,2000);

vec4 cloudcolor=vec4(1,1,1,0);
vec2 uvo=ouv;
vec2 duvo=vec2(time,0)*speed;
for (int i=layer;i>=0;--i)
{
//float h=20*camdir.y;float r=((1<<i)*h-camera_pos.y)/(h-camera_pos.y);vec2 uv=uvo*r+duvo;
vec2 uv=uvo*(1<<i)+duvo;
vec4 tx=texture(diffuseMap,uv);
cloudcolor=mix(cloudcolor,vec4(tx.rgb,1),tx.a);
uvo=vec2(uvo.y,-uvo.x);
duvo=vec2(duvo.y,-duvo.x);
}
cloudcolor+=cloudcolor.a*(1-cloudcolor.a)*pow(cdcl,4)*1.2;
gl_FragColor = mix(color+suncolor, cloudcolor,cloudcolor.a)*light_diffuse_colour;
gl_FragColor = mix(gl_FragColor, fog_colour,vfogf);
}