varying vec4 vposw;
varying vec2 vuv0;
varying vec2 vuv1;
varying float vdist;
uniform vec4 fog_colour;//+30
uniform vec4 fog_params;//+31
uniform vec4 surface_emissive_colour;//+35
uniform float shininess;//+36
uniform vec4 light_pos;//+43
uniform vec4 ambient_ml;//+67
uniform vec4 diffuse_ml;//+69
uniform vec4 specular_ml;//+70
uniform vec4 camera_pos;//+76
uniform sampler2D alt;//0
uniform sampler2D color;//1
uniform sampler2D tcolor;//2
uniform sampler2D tnorm;//3

uniform float height2;//8
uniform vec4 water_params;//0 0 20 0.050

void main()
{
float f;vec4 fc;vec4 coloratt=vec4(1);
if (vposw.y<0) 
{
if (camera_pos.y>=0) f = min(vdist*-vposw.y/(camera_pos.y-vposw.y) * water_params.w,1); else f = min(vdist* water_params.w,1);
fc=surface_emissive_colour;	if (f==1){gl_FragColor=fc;return;}
coloratt=vec4(0.8,0.8,0.8,0);
}
else 
{
f = min(vdist * fog_params.w,1);
fc=fog_colour;	if (f==1){gl_FragColor=fc;return;}
}

vec3 vlightdir = normalize(light_pos.xyz - vposw.xyz);
vec3 vviewdir = normalize(camera_pos.xyz - vposw.xyz);

vec4 tx1=texture(alt,vuv0)+texture(alt,vuv1)-1;tx1.xy*=height2;
vec4 tx2=texture(tnorm,vuv1*64)-0.5;tx2.xy*=(2+length(tx1.xy)*8);
vec3 nor = normalize(tx1.xzy+tx2.xzy);
vec4 vcolor=texture(color,vuv0)+texture(color,vuv1);
vec4 fcolor=vec4(texture(tcolor,vuv1*64).rgb,1) * vcolor * coloratt;
float dif=max(dot(vlightdir, nor), 0);
float spe=pow(max(dot(normalize(vlightdir + vviewdir), nor), 0),shininess);
gl_FragColor=fcolor*(ambient_ml + diffuse_ml*dif)+ fcolor.a*specular_ml*spe;
gl_FragColor=mix(gl_FragColor,fc,f);
}