varying vec2 ouv;
varying vec4 opos_w;
varying float 	vdist;
varying vec2 	vuv;
uniform vec4 fog_colour;//+30
uniform vec4 fog_params;//+31
uniform float shininess;//+36
uniform vec4 light_specular_colour;//+40
uniform vec4 light_pos;//+43
uniform vec4 diffuse_ml;//+69
uniform vec4 specular_ml;//+70
uniform vec4 camera_pos;//+76
uniform float time;//+86
uniform vec4 water_params;//0 0 40 0.025

uniform sampler2D normalMap;//0

void main()
{
float f;
vec4 fc;
if (camera_pos.y<0) 
{f = min(vdist * water_params.w,1);fc=vec4(diffuse_ml.rgb,1);}
else 
{if (fog_params.z == 0) f=0; else f = min(vdist * fog_params.w,1);fc=fog_colour;}
if (f==1){gl_FragColor=fc;return;}

vec2 duv=vec2(time*0.01,0);
vec3 normal=normalize(texture(normalMap,ouv+duv).xyz+texture(normalMap,ouv+0.5-duv).xyz-1).xzy;  
vec3 lightdir=normalize(light_pos.xyz-opos_w.xyz);lightdir.y*=sign(camera_pos.y); 
vec3 viewdir=normalize(camera_pos.xyz-opos_w.xyz);
float cfresnel = 1-abs(dot(viewdir, normal));
vec4 color=mix(diffuse_ml,specular_ml,cfresnel*cfresnel);
color+=light_specular_colour*pow(dot(normalize(lightdir + viewdir), normal),shininess);

gl_FragColor=mix(color ,fc, f);
}